//
// Course.cpp
//
// LECTURE 12
// DEMO 3
//
#include "StdAfx.h"

#include <iostream>
#include <string>

using namespace std;  //introduces namespace std
#include "Course.h"

Course::Course()
{
  numStudents = maxStudents = 0;
  studentList = NULL;
}

Course::Course(string theName,string theInstructor,int theCount)
{
  numStudents = maxStudents = 0;
  studentList = NULL;
  
  instructor = theInstructor;
  name = theName;
  
  if (theCount > 0)
  {
    studentList = new Student[theCount];
    if (studentList)
      maxStudents = theCount;
  }
}

Course::~Course()
{
  cout << "In Course's destructor" << endl;
  if (studentList)
    delete [] studentList;
}


int Course::getStudentCount()
{
  return numStudents;
}

string Course::getCourseName()
{
  return name;
}

string Course::getInstructor()
{
  return instructor;
} 

void Course::setStudentCount(int count)
{
  numStudents = count;
}

void Course::setCourseName(string theName)
{
  name = theName;
}

void Course::setInstructor(string theInstructor)
{
  instructor = theInstructor;
}

bool Course::addStudent(Student &aStudent)
{
  if (numStudents >= maxStudents)
    return false;
    
  studentList[numStudents++] = aStudent;
  return true;
}

void Course::printList()
{
  cout << "Course listing for: " << name << endl;
  cout << "Instructor:         " << instructor << endl;
  cout << "Max enrollment:     " << maxStudents << endl;
  cout << "Current enrollment: " << numStudents << endl;
  cout << "======================================================= " << endl;
  cout.width(15);
  cout << "NAME";
  cout.width(20);
  cout << "ADDRESS";
  cout.width(10);
  cout << "PHONE";
  cout << endl;
  
  for (int i=0; i<numStudents; i++)
  {
    cout.width(15);
    cout << studentList[i].getName();
    cout.width(20);
    cout << studentList[i].getAddr();
    cout.width(10);
    cout << studentList[i].getPhone();
    cout << endl;
  }
  
  cout << "------------------------------------------------------- " << endl;
}